### Hierarchy

- Options
  - AuthenticationTypeOAuth2

## Index

### Properties

- accessToken
- accessUrl
- clientId
- clientSecret
- expires
- privateKey
- refreshToken
- timeout
- user

### Methods

- provisionCallback

## Properties

### Optional accessToken

accessToken: undefined | string

- Defined in node_modules/@types/nodemailer/lib/xoauth2.d.ts:24

An existing valid accessToken

### Optional accessUrl

accessUrl: undefined | string

- Defined in node_modules/@types/nodemailer/lib/xoauth2.d.ts:22

Endpoint for token generation, defaults to 'https://accounts.google.com/o/oauth2/token'

### Optional clientId

clientId: undefined | string

- Defined in node_modules/@types/nodemailer/lib/xoauth2.d.ts:16

Client ID value

### Optional clientSecret

clientSecret: undefined | string

- Defined in node_modules/@types/nodemailer/lib/xoauth2.d.ts:18

Client secret value

### Optional expires

expires: ms

- Defined in node_modules/@types/nodemailer/lib/xoauth2.d.ts:28

Optional Access Token expire time in ms

### Optional privateKey

privateKey: string | object

- Defined in node_modules/@types/nodemailer/lib/xoauth2.d.ts:26

Private key for JSW

### Optional refreshToken

refreshToken: undefined | string

- Defined in node_modules/@types/nodemailer/lib/xoauth2.d.ts:20

Refresh token for an user

### Optional timeout

timeout: s

- Defined in node_modules/@types/nodemailer/lib/xoauth2.d.ts:30

Optional TTL for Access Token in seconds

### Optional user

user: undefined | string

- Defined in node_modules/@types/nodemailer/lib/xoauth2.d.ts:14

User e-mail address

## Methods

### Optional provisionCallback

- provisionCallback(user: string, renew: boolean, callback: function): void

- - Defined in node_modules/@types/nodemailer/lib/xoauth2.d.ts:32

  Function to run when a new access token is required

  #### Parameters

  - ##### user: string

  - ##### renew: boolean

  - ##### callback: function

    - - (err: Error | null, accessToken: string, expires: number): void

      - #### Parameters

        - ##### err: Error | null

        - ##### accessToken: string

        - ##### expires: number

        #### Returns void

Generated using TypeDoc